;================================
;          ZX-Assembler-2 
;      by Artic Computing LTD
;================================

@PrintAT=08F5
@PRStr4=0B6B
@OutNo=0AA5			;Writes number to edit line
@DFxCC=400E
@Frames=4034
@LastK=4025
@DFile=400C
@XCoord=4036
@YCoord=4037
@PRBuff00=403C
@PRBuff02=403E
@PRBuff04=4040
@PRBuff05=4041
@PRBuff06=4042
@PRBuff07=4043
@Scroll21=487D

ORG 4C08

	JR Breakout		;19464
	JP Starship		;19466
;================================
@PrintA
	PUSH BC 
	PUSH AF 
	CALL PrintAt
	LD HL,(DFxCC)		;Get address of PRINT position
	LD D,(HL) 
	POP AF 
	RST 10			;Display=A reg.
	POP BC 
	RET
;==========================
@Collision
	XOR A 
	CP (HL) 
	JR NZ +3
	INC (HL) 
	INC (HL) 
	RET
	DEC (HL) 
	DEC (HL) 
	RET
;==========================
@Paddle
	LD A,0B 		;11
	CP C 
	JR NZ +1
	DEC C 
	LD A,00 
	CP C 
	RET NZ 
	INC C 
	RET
;==========================
@BO03
	LD L,A 
	LD H,00 
	PUSH HL 
	CALL PrintAt
	POP HL 
	CALL OutNo+6
	RET
;==========================
@BOSpeed
	LD B,08 
	LD C,FF 
	DEC C 
	JR NZ -3
	DJNZ -7
	RET
;==========================
@Breakout
	CALL Scroll21
	LD (IY+64),00		;PRBuff04, Reset Score
	LD (BOSpeed+1),A	;Set speed
	LD A,83			;Print "\.."x13, right side
	LD BC,0D1A 		;Y=13, X=26
	CALL PrintA
	DJNZ -5			;Decrease Y, repeat
	LD B,00 		;Y=0
	CALL PrintA 		;Print top edge
	LD B,0D 		;Y=13
	CALL PrintA		;Print bottom side
	DEC C 			;Decrease X
	JR NZ -13
	LD C,14 		;X=20
	LD B,0C 		;Y=12
	LD A,95 		;Print g+ bricks
	CALL PrintA
	DJNZ -5
	DEC C 			;Dec X
	LD A,C 
	CP 11
	JR NZ -15		;Print 3 layers
	LD B,0C 		;Y=12
	LD A,08 		;Print \## bricks
	CALL PrintA
	DJNZ -5
	DEC C 			;Dec X
	LD A,C 
	CP 0E
	JR NZ -15		;Print 3 layers
	LD (IY+62),02 		;PRBuff02
	LD (IY+65),00 		;PRBuff05
@BallLoop
	LD A,(Frames)
	AND 0B 
	CP 02
	JR C -9
	LD (IY+55),A 		;YCoord
@BO04
	LD A,(Frames)
	AND 02 
	BIT 0,A 
	JR NZ -9
	LD (IY+60),A		;PRBuff00
	LD (IY+61),02 		;PRBuff01
@BO05
	LD C,(IY+62) 		;PRBuff02
	LD A,(LastK)
	CP FD	 		;Down?, Keys A to G
	JR NZ +3
	INC C 
	JR +5
@BO06
	CP FB			;Up?, Keys Q to T
	JR NZ +4
	DEC C 
@BO07
	CALL Paddle 
	LD (IY+62),C		;PRBuff02 
	LD HL,(DFile)
	INC HL 
	INC HL 
	PUSH HL 
	LD B,0C 
	LD DE,001C 
	ADD HL,DE 
	LD (HL),D 
	DJNZ -5
	POP HL 
	LD B,03 
	ADD HL,DE 
	DEC C 
	JR NZ -4
	LD (HL),85 
	ADD HL,DE 
	DJNZ -5
	CALL BOSpeed
	LD BC,(Xcoord)
	XOR A 
	CP C 
	JR Z BO09
	CALL PrintA
	LD DE,Ycoord
	LD A,(IY+60)		;PRBuff00 
	ADD A,B 
	DEC A 
	LD B,A 
	LD (DE),A 
	DEC DE 
	LD A,(IY+61) 		;PRBuff01
	ADD A,C 
	DEC A 
	LD C,A 
	LD (DE),A 
	LD A,34 
	CALL PrintA
	LD A,B 
	LD HL,PRBuff00
	CP 01
	JR Z BO11
	CP 0C
	JR Z BO11
@BO08
	LD A,C 
	CP 19
	JR Z BO12
	CP 00
	JR Z BO09
	LD A,D 
	CP 85			;Paddle
	JR Z BO12
	LD E,01 		;Grey brick value
	CP 08			;Grey brick
	JR Z +5
	CP 95			;g+ Brick
	JR NZ BO05
	INC E 			;g+ Brick value
;Update Score
	LD A,(IY+64)		;PRBuff04 		
	ADD A,E 
	LD (IY+64),A 		;PRBuff04
	JR BO12
@BO09
	INC (IY+65) 		;PRBuff05
	LD (IY+61),02 		;PRBuff01
	XOR A 
	CALL PrintA
	LD A,(PRBuff04)
	LD BC,0D02 
	LD DE, BO10 
	PUSH DE 
	CALL BO03
@BO10
	LD (IY+54),08 		;Xcoord
	JR BO13
@BO11
	CALL Collision
	JR BO08
@BO12
	INC HL 
	CALL Collision
	JP BO05
@BO13
	LD HL,(DFile)
	INC HL 
	LD A,(PRBuff05)
	ADD A,9C 
	LD (HL),A 
	CP A3			;g7, Game over test
	JP NZ BallLoop
	LD BC,0000
	RET
;==========================
@Starship
	LD HL,Scroll21+5	;Set scroll line counter
	LD (HL),0B
	CALL Scroll21
	LD (PlaneSpeed+1),A	;Set speed
	LD BC,0160 		;Clear screen
	XOR A 
	RST 10
	DEC BC 
	LD A,B 
	OR C 
	JR NZ -7
	LD HL,(DFxCC)
	DEC HL 
	LD (PRBuff00),HL
	PUSH HL 
	LD A,9D 		;Fuel guage
	LD BC,0F1E 
	RST 10
	INC A 
	DJNZ -4
	LD HL,(DFxCC)		;Build city
	DEC HL 
	LD (PRBuff02),HL
	POP HL 
	CALL City
	LD HL,(DFile)
	LD E,03 
	ADD HL,DE 
	LD (PRBuff04),HL
	LD A,0F 
	LD (PRBuff06),A
@PlaneSpeed
	LD B,10 		;Speed delay
	DEC BC 
	LD A,C 
	OR B 
	JR NZ -5
	LD DE,0021 
	LD HL,(PRBuff04)
	PUSH HL 
	LD A,(PRBuff06)
	OR D 
	JR Z +37
	LD A,(LastK)
	CP FB			;Up, Q to T
	JR NZ +26
;================================
	SBC HL,DE 		;Ship up section
	PUSH HL 
	LD BC,(DFile)
	SBC HL,BC 
	POP HL 
	JR C +18
	PUSH HL 
	LD HL,PRBuff06
	DEC (HL) 
	LD HL,(PRBuff02)
	LD (HL),D 
	DEC HL 
	LD (PRBuff02),HL
	POP HL
;================================ 
	CP FD			;Down, A to G
	JR NZ +1
	ADD HL,DE 		;Ship down section
	PUSH HL 
	LD BC,(PRBuff00)
	SBC HL,BC 
	POP HL 
	JR NC +95
	INC HL 
	LD A,(HL) 
	CP 76
	JR +2
	JR PlaneSpeed
	JR NZ +3
	INC HL 
	INC HL 
	INC HL 
	LD B,03 
	LD A,(HL) 
	CP 88			;Building chr.
	JR Z +86
	DEC HL 
	DJNZ -8
	INC HL 
	INC HL 
	INC HL 
	LD (PRBuff04),HL
	EX (SP),HL 
	LD (HL),D 
	DEC HL 
	LD (HL),D 
	DEC HL 
	LD (HL),D 
	POP HL 
	CALL Plane
	EXX 
	PUSH BC 
	EXX 
	POP BC 
	LD HL,(PRBuff07)
	BIT 0,C 
	JR NZ +14
	LD HL,(PRBuff04)
	DEC HL 
	LD A,(LastK)
	CP BF			;Bomb, H,J,K,L
	JR NZ +25
;================================
	INC C 			;Bomb drop
	LD B,05 
	LD (HL),D 
	ADD HL,DE 
	PUSH HL 
	LD DE,(PRBuff00)
	SBC HL,DE 
	POP HL 
	JR C +3
	INC C 
	JR +7
	DJNZ +3
	INC C 
	JR +2
	LD (HL),04		;Bomb chr.
;================================
	PUSH BC 
	EXX 
	POP BC 
	EXX 
	LD (PRBuff07),HL
	JR -89
	POP HL 
	CALL Plane
	LD DE, Safe
	LD C,0C 
	JR +25
	POP HL 
	LD DE,0021 
	LD (HL),17 
	SBC HL,DE 
	SBC HL,DE 
	LD (HL),02 
	DEC HL 
	LD (HL),1B 
	ADD HL,DE 
	ADD HL,DE 
	LD (HL),D 
	DEC HL 
	LD (HL),16 
	LD DE, Crash
	LD C,09 
	LD B,00 
	LD HL,DFxCC 
	INC (HL) 
	INC (HL) 
	JP PRSTR4
;==========================
@Safe 
	B8 A6 AB AA 80 B1 A6 B3 A9 AE B3 AC
@Crash
	17 17 A8 B7 A6 B8 AD 17 17
;==========================
@City
	LD DE,0021 
	DEC HL 
	PUSH HL 
	LD HL,(Xcoord)
	DEC HL 
	LD A,H 
	CP 18
	JR C +2
	LD H,18 
	LD A,(HL) 
	LD (Xcoord),HL
	POP HL 
	AND 07 
	INC A 
	LD B,A 
	PUSH HL 
	LD (HL),88			;Building chr.
	SBC HL,DE 
	DJNZ -6
	POP HL 
	DEC HL 
	DEC C 
	JR NZ -33
	RET
;==========================
@Plane
	LD (HL),2E 
	DEC HL 
	LD (HL),9C 
	DEC HL 
	LD (HL),82 
	RET