;================================
;          ZX-Assembler-2 
;      by Artic Computing LTD
;================================

@CLS=0A2A
@DFile=400C
@PRBuff00=403C
@PRBuff02=403E
@Frames=4034
@SpeedX=4998			;18840

ORG 55DE

;================================
; Cosmic Raider
;================================
@Raider
	CALL CLS
	LD A,(SpeedX)		;Get speed
	LD (Speed+1),A		;Set speed
	LD A,80 
	LD C,09 
	LD B,20 
	RST 10
	DJNZ -3
	DEC C 
	JR NZ -8
	LD DE,(DFile)
	INC DE 
	LD HL,ScoreHi 
	LD C,20 
	LDIR 
	INC DE 
	LD (PRBuff00),DE
	XOR A 
	LD (PRBuff02),A
@Raid01
	LD HL,(PRBuff00)
	LD DE,0021
;Up/Down
	LD A,FB
	IN A,FE 		;Keyboard Port.
	CP +126 		;Up?
	JR NZ +4		;Jump if not up key
	SBC HL,DE
	JR Raid02
	LD A,FD
	IN A,FE			;Keyboard Port.
	CP +126			;Down?
	JR NZ +1
	ADD HL,DE 
@Raid02 
	LD A,(HL)
	CP 80			;"g "? Vacuum of space
	JR Z Raid03		;Jump if space
	CP 00			;" "? Mountain
	JR NZ Cloud		;Jump if not mountain
@Killed
	LD (HL),97		;"g*"
	LD HL,(DFile)
	LD DE,0020 
	ADD HL,DE 
	LD DE,HiScore 
	LD C,04 
	LDDR 
	RET
@Cloud
	CP 88 			;Killer cloud?
	JR Z Killed		;Die if killer cloud
	CP B4 			;"gO", Alien
	JR Z Killed		;Die if alien
	CP 96 			;"g-", Missile
	JR Z +5
	LD HL,(PRBuff00)
	JR Raid02
@Raid03
	LD (HL),92		;"g>", Ship
	LD (PRBuff00),HL
	LD HL,(DFile)
	ADD HL,DE 
	LD BC,0008 
@Fire
	INC HL 
	CP 96 			;"g-", Missile
	CP (HL) 
	JR NZ +1
	DEC C 
	DJNZ Fire
	LD (PRBuff02),A
	XOR A 
	SBC A,C 
	JR C +3
	LD (PRBuff02),A
	LD A,(PRBuff02)
	CP 00
	JR Z Raid04
;Fire Missile
	LD A,7F			;Section 7
	IN A,FE			;Keyboard Port.
	CP +123			;"M" Key?
	JR NZ Raid04		;Jump if not fire key
	LD HL,(PRBuff00)	;Shoot
	INC HL 
	LD A,80 
	CP (HL) 
	JR NZ +2
	LD (HL),96 		;"g-"
@Raid04
	LD HL,(DFile)
	LD B,08 
	ADD HL,DE 
	DJNZ -3
@Raid04b
	PUSH BC 
	DEC HL 
	PUSH HL 
	INC HL 
	LD A,96 		;"g-"
	CP (HL) 
	JR NZ Raid06
	LD (HL),80 
	LD A,(HL) 
	INC HL 
	CP (HL) 
	JR Z Raid05
@AlienHit
	LD A,(HL) 
	CP B4 			;"gO"
	JR NZ Raid06
	LD (HL),97		;"g*" 
	LD HL,(DFile)
	LD DE,0009 
	ADD HL,DE 
	PUSH HL 
	PUSH HL 
	LD E,17 
	ADD HL,DE 
	EX DE,HL 
	POP HL 
	LD B,03 
	LD A,(DE) 
	CP (HL) 
	JR NZ +14
	DEC HL 
	DEC DE 
	DJNZ -8
	LD HL,(DFile)		;Update HiScore
	LD DE,0020 
	ADD HL,DE 		;HiScore
	CALL Update
	POP HL 
	CALL Update
	JR +6
@Raid05
	INC HL 
	CP (HL) 
	JR NZ AlienHit
	LD (HL),96 		;"g-"
@Raid06
	POP HL 
	POP BC 
	DJNZ Raid04b
@Speed
	LD B,16 
	DEC C 
	JR NZ -3
	DJNZ -5
	LD HL,(DFile)
	PUSH HL 
	LD DE,0021 
	PUSH DE 
	ADD HL,DE 
	PUSH HL 
	POP DE 
	LD A,08 
	INC HL 
	INC HL 
	INC DE 
	LD BC,001F 
	LDIR 
	INC DE 
	DEC A 
	JR NZ -12
	POP DE 
	POP HL 
	ADD HL,DE 
	ADD HL,DE 
	DEC HL 
	PUSH HL 
	CALL RndNum
	AND 03 
	ADD A,04 
	LD C,A 
	LD B,A 
	LD (HL),80 
	ADD HL,DE 
	DJNZ -5
	XOR 07 
	INC A 
	LD (HL),00 
	ADD HL,DE 
	DEC A 
	JR NZ -6
	LD H,C 
	CALL RndNum
	AND H 
	POP HL 
	CP 00
	JR Z +4
	ADD HL,DE 
	DEC A 
	JR NZ -4
	LD (HL),88 		;Killer cloud
	CALL RndNum
	AND 03 
	CP 00
	JR NZ +2
	LD (HL),B4 
	CP 03
	JR C +2
	LD (HL),80 
	LD HL,(DFile)
	ADD HL,DE 
	LD B,00 
@Raid07
	PUSH BC 
	LD A,97 
	CP (HL) 
	JR NZ +2
	LD (HL),80 
	LD A,B4 
	CP (HL) 
	JR NZ Raid09
	CALL RndNum
	AND 03 
	CP 03
	JR C Raid08
	ADD HL,DE 
	LD A,80 
	CP (HL) 
	JR NZ +8
	LD (HL),B4 
	SBC HL,DE 
	LD (HL),80 
	JR Raid09
	SBC HL,DE 
	JR Raid09
@Raid08
	CP 00
	JR NZ Raid09
	SBC HL,DE 
	LD A,80 
	CP (HL) 
	JR NZ +7
	LD (HL),B4 
	ADD HL,DE 
	LD (HL),80 
	JR +1
	ADD HL,DE 
@Raid09
	POP BC 
	INC HL 
	DJNZ Raid07
	JP Raid01
;==========================
@RndNum
	LD BC,(Frames)
	DEC BC 
	LD (Frames),BC
	LD B,03 
	LD A,(BC) 
	RET
;==========================
@Update
	INC (HL)		;Get digit 
	LD A,A6 		;"gA"
	CP (HL) 		;Test digit
	RET NZ			;Return if not "gA" 
	LD (HL),9C 		;"g0", Replace "gA" with "g0"
	DEC HL 			;Next digit
	JR -10
;==========================
@ScoreHi

B8 A8 B4 B7 AA 92 9C 9C
9C 8A 8A A8 B4 B8 B2 AE
A8 8A B7 A6 AE A9 AA B7
8A 8A AD AE 92 9C 9C

@HiScore
9C 00

