;================================
;          ZX-Assembler-2 
;      by Artic Computing LTD
;================================

@DFile=400C
@Humanoids=403F
@PRBuff00=403C
@PRBuff05=4041
@PRBuff02=403E
@Frames=4034
@Easy=4036
@Scroll21=487D
@Score=48D5
@HiScore=48EF
@SpeedX=4998			;18840

ORG 57C2			;22466

;================================
; Defender
;================================
@Defender
	LD A,(Easy)			;Set difficulty
	LD HL,2323
	LD B,02
	AND A
	JR Z +7				;Jump if easy
	LD L,00
	DEC B
	DEC A
	JR Z +1				;Jump if medium
	LD H,L
	LD A,B
	LD (Missiles+1),A
	LD (Gaps),HL
	CALL Scroll21			;Collapse display
	LD (Speed+1),A			;Set Speed
	LD A,9C				;Reset score
	LD HL,Score+6
	LD (HL),A
	INC HL
	LD (HL),A
	INC HL
	LD (HL),A
	LD C,08				;Row counter
	LD A,C				;Define play are with
	LD B,1B				;Column counter 
	RST 10
	DJNZ -3				;Column loop
	LD A,76 
	RST 10
	DEC C 
	JR NZ -12			;Row loop
	LD HL,Score 			;Copy score line
	LD DE,(DFile)
	INC DE 
	LD C,1B				;Column count				
	LDIR 				;Print score
	XOR A 
	LD (Humanoids),A		;Reset humanoid count
@Restart
	LD HL,(DFile)			;Clear play area
	LD DE,001C 			;Offset to next row
	ADD HL,DE 
	INC HL 
	LD (PRBuff00),HL
	DEC HL 
	PUSH HL 
	LD C,07 
	LD B,1B				;Column count 
	INC HL 
	LD (HL),80 			;Print "g "
	DJNZ -5				;Column loop
	INC HL 
	DEC C 
	JR NZ -11			;Row loop
	LD A,(Humanoids)		;Get humanoids count
	INC A 
	CP 06				;Max count=5
	JR NZ +1			;Jump if count<6
	DEC A 
	LD (Humanoids),A
	LD (PRBuff05),HL
	LD B,A 
	DEC HL 
	LD (HL),AE			;"g", Humanoid
	DJNZ -5
	POP HL 
	ADD A,A 			;A=Hmanoids*2
	LD B,A 				;Alien count=Hmanoids*2
@Defend02
	PUSH HL 
	CALL RndNum
	AND 0F 				;Range 0 to 15
	ADD A,0A 			;Range 10 to 25
	INC HL 
	DEC A 
	JR NZ -4
	LD A,80 			;"g "
	CP (HL) 
	JR NZ Defend02+1		;Jump if not "g "
	LD (HL),A6			;"gA" Alien-A
	POP HL 
	DJNZ Defend02			;Loop until B=0
@GameLoop
	LD HL,(PRBuff00)
	LD DE,001C 			;28, row offset
;Up/Down
	LD A,FB
	IN A,FE 			;Keyboard Port.
	CP +126 			;Up?
	JR NZ +4			;Jump if not up
	SBC HL,DE 			;Subtract offset
	JR Defend04
	LD A,FD
	IN A,FE 			;Keyboard Port.
	CP +126 			;Up?
	JR NZ +1			;Jump if not down
	ADD HL,DE 			;Add offset
@Defend04
	LD A,(HL) 
	CP 80				;"g "
	JR Z Space
	CP B8 				;"gS"? Top edge
	JR Z Edge			;Jump if top edge
	CP 76				;EOL? Bottom edge
	JR Z Edge			;Jump if bottom edge
@GameOver
	LD (HL),88 			;Grey Block
	LD HL,(DFile)			;Save Hiscore
	LD E,1B 
	ADD HL,DE 
	LD DE,HiScore			
	LD BC,0003 
	LDDR 
	RET
;==========================
@Edge
	LD HL,(PRBuff00)
	JR Defend04
@Space
	LD (HL),92			;"g>", Ship
	LD (PRBuff00),HL
	LD HL,(DFile)
	ADD HL,DE 
	LD BC,0008			;Missile count 
	INC HL 
	LD A,96 			;"g-", missile
	CP (HL) 
	JR NZ +1
	DEC C 
	DJNZ -9
	LD (PRBuff02),A
	XOR A 
	SBC A,C 
	JR C +3
	LD (PRBuff02),A
	LD A,(PRBuff02)
	CP 00				;
	JR Z Defend05
;Fire Missile
	LD A,7F				;Section 7
	IN A,FE				;Keyboard Port.
	CP +123				;"M" Key?
	JR NZ Defend05			;Jump if not "M"
;Fire
	LD HL,(PRBuff00)
	INC HL 
	LD (HL),96 			;"g-", missile
@Defend05
	LD HL,(DFile)
	LD B,08 
	ADD HL,DE 
	DJNZ -3
@Defend06
	PUSH BC 
	DEC HL 
	PUSH HL 
	INC HL 
	LD A,96 			;"g-", missile
	CP (HL) 
	JR NZ Defend50
	LD (HL),80			;Erase missile
	LD A,(HL)			;Print "g " 
	INC HL 
	CP (HL) 
	JR Z Defend49
@Defend07
	LD A,(HL) 
	CP A6				;"gA", Alien-A
	JR Z +4
	CP B2				;"gM", Mutant-M
	JR NZ Defend50			;Jump if not mutant
	LD (HL),80 			;"g "
	LD HL,(DFile)
	LD DE,0009 
	ADD HL,DE 
	PUSH HL 
	PUSH HL 
	LD E,12 			;High score 1st digit 
	ADD HL,DE 
	EX DE,HL 
	POP HL 
	LD B,03				;Test for high score 
	LD A,(DE) 
	CP (HL) 
	JR NZ Defend08
	DEC HL 
	DEC DE 
	DJNZ -8
	LD HL,(DFile)
	LD DE,001B 
	ADD HL,DE 
	CALL Update			;Update hiscore
@Defend08
	POP HL 
	CALL Update			;Update score
	JR Defend50
@Defend49
	INC HL 
	CP (HL) 
	JR NZ Defend07
	LD (HL),96			;"g-", missile
@Defend50
	POP HL 
	POP BC 
	DJNZ Defend06
	LD DE,001C			;Row offset 
	LD HL,(DFile)
	LD B,E0 			;8*28=224
@Defend51
	PUSH BC 
	INC HL 
	LD C,(HL) 
	INC C 
	LD A,C 
	CP B3				;"gN", Mutant-N
	JR Z Defend52
	CP A7				;"gB", Alien-B
	JR NZ Defend54			;Jump if not "gB"
	LD B,05 
	PUSH HL 
	ADD HL,DE 
	LD A,AE				;"gI", Humanoid
	CP (HL) 
	JR Z +5				;Jump if humanoid
	DJNZ -8
	POP HL 
	JR Defend52
	POP HL 
	PUSH HL 
	ADD HL,DE 
	CP (HL) 
	JR NZ +4
	LD (HL),80 			;"g "
	LD C,B3				;"gN", Mutant-N
	JR Defend53
@Defend52
	PUSH HL 
	DEC HL 
	CALL RndNum
	AND 01 				;1 or 0?
	JR Z +3				;Jump if 0
	ADD HL,DE 
	JR +2
	SBC HL,DE
@Defend53
	LD A,(HL) 
	CP 76				;EOL?
	JR NZ +2
	DEC HL 
	LD A,(HL) 
	CP 80				;"g "
	JR NZ +5
	LD (HL),C 
	POP HL 
	LD (HL),A 
	JR Defend54
	POP HL 
	LD (HL),C 
@Defend54
	POP BC 
	DJNZ Defend51
	LD HL,(DFile)
	ADD HL,DE 
	LD E,00 
	LD C,C4				;Play area byte count,7*28=196
@TrackMissiles
	INC HL 
	LD A,(HL) 
	CP A7				;"gB", Alien-B
	JR NZ +2
	DEC (HL)			;"gB"->"gA" 
	INC DE 
	CP 97				;"g*", Mutant bomb
	JR NZ Defend56
@Missiles
	LD B,02 			;Erase bomb
	LD (HL),80 			;"g "
	DEC HL 
	LD A,(HL) 
	CP 76				;EOL
	JR Z Gaps+1
	DJNZ Missiles+2
	LD B,A 				;Missile hit?
	DEC HL 
	LD A,(HL) 
	CP 92				;"g>"
	JP Z  Gameover
	LD A,B 
	INC HL
	LD (HL),97			;"g*", Mutant bomb
@Gaps 	
	INC HL 
	INC HL 
@Defend56
	CP B3 				;"gN", Mutant-N
	JR NZ Defend57
	DEC (HL) 			;"gN->"gM"
	INC DE 
	CALL RndNum
	AND 07 				;Range 0 to 7
	JR NZ Defend57
	DEC HL 
	LD A,80				;"g " 
	CP (HL) 
	JR NZ +2
	LD (HL),97			;"g*", Mutant bomb
	INC HL 
@Defend57
	DEC C 
	JR NZ TrackMissiles
	CALL Delay
	JP Z Restart
	LD HL,(PRBuff00)
	LD A,92				;"g>", Ship
	CP (HL) 
	JR NZ +2			;Jump if not ship
	LD (HL),80 			;Erase ship
;Boost
	LD A,7F				;Section 7 
	IN A,FE				;Keyboard Port.
	CP +111				;"B" key? 
	JR NZ Defend59			;Jump if not boost
	LD HL,(DFile)
	LD DE,001C			;Row offset 
	ADD HL,DE 			;Start of row 1
	PUSH HL 
	POP DE 
	LD B,07				;Row count 
@Defend58
	INC HL 
	LD A,(HL) 
	PUSH BC 
	INC HL				;Shift row left
	INC DE 
	LD BC,001A			;Byte count
	LDIR 
	DEC HL 
	POP BC 
	CP 97				;"g*", Mutant bomb
	JR NZ +2			;Jump if not mutant missile
	LD A,80				;Erase mutant missile
	LD (HL),A 
	INC HL 
	INC DE 
	DJNZ Defend58
@Defend59
	JP GameLoop
	RET
@Delay
	PUSH BC
@Speed
	LD B,16 
	DEC C
	JR NZ -3
	DJNZ -5
	LD A,D 				;DE=001C
	OR E 
	POP BC
	RET
;==========================
@RndNum
	PUSH BC
	LD BC,(Frames) ; GET Frames
	DEC BC 
	LD (Frames),BC ; SET Frames
	LD B,03 
	LD A,(BC) 
	POP BC
	RET
;==========================
@Update
	INC (HL) 
	LD A,A6				;"gA" Digit overflow
	CP (HL) 
	RET NZ 
	LD (HL),9C			;"g0" 
	DEC HL 
	JR Update
;==========================
