;================================
;          ZX-Assembler-2 
;      by Artic Computing LTD
;================================

@CLS=0A2A
@Keyboard=02BB
@Decode=07BD
@PrintAt=08F5
@DFile=400C
@LastK=4025
@Frames=4034
@Scroll21=487D

ORG 5A23			;23075

;================================
; Snake
;================================
@Snake
	CALL CLS
	CALL Scroll21
	LD C,10			;10 columns 
	LD B,15 		;21 rows
	PUSH BC			;Draw background
	DEC C 
	CALL PrintAt
	POP BC 
	LD A,80 
	RST 10
	DJNZ -11
	DEC C 
	JR NZ -16
	CALL PrintAt
	LD A,"0"		;Initialize score 
	RST 10
	RST 10
	RST 10
	LD A,FF 
	LD (SnakeG),A 
	LD HL,SnakeC 
	LD (SnakeA),HL 
	LD HL,(DFile)			;
	LD DE,001D 
	ADD HL,DE 
	EX DE,HL 
	LD HL,SnakeB 
	LD B,14 
	LD (HL),E 
	INC HL 
	LD (HL),D 
	INC HL 
	PUSH HL 
	LD H,D 
	LD L,E 
	LD DE,0011 
	ADD HL,DE 
	LD D,H 
	LD E,L 
	POP HL 
	DJNZ -16
@Snake01
	LD HL,(SnakeF) 
	LD A,01 
	CP H 
	JR NC +8
	LD BC,0064 
	SBC HL,BC 
	LD (SnakeF),HL 
	LD B,H 
	PUSH BC 
	CALL Keyboard
	POP BC 
	DJNZ -7
	BIT 0,H 
	JR Z +105
	LD B,H 
	LD C,L 
	INC H 
	JR Z +100
	CALL Decode
	LD A,(HL) 			;A=Key code
	LD HL,SnakeE 
	CALL NewSort
	JR NZ NoKey			;Jump if not Q,A,O or P key
	00 00 00
	LD B,00 
	LD C,A 
	ADD HL,BC 
	LD E,(HL) 
	LD D,00 
	LD HL,(SnakeB) 
	LD C,11 
	AND A 
	SBC HL,BC 
	ADD HL,DE 
	LD A,(HL) 
	CP 80				;Background
	JR Z +38
	CP 08				;Gray body
	JR Z +34
	CP 06				;Rattler
	JR Z +30
	CP 8D				;g$
	JR Z +2
	JR +87
	PUSH HL 
	LD HL,(DFile)			;Update score
	INC HL 
	INC HL 
	INC HL 
	LD A,(HL) 
	CP 25				;"9"
	JR NZ +10
	LD A,96
	LD (SnakeG),A 
	LD (HL),1C  			;Rollover 9 to 0
	DEC HL				 
	JR -15				;Do next digit
	INC (HL) 
	POP HL 
	PUSH HL 
	LD HL,(SnakeA) 
	LD E,(HL) 
	INC HL 
	LD D,(HL) 
	LD A,80 
	LD (DE),A 
	LD DE,SnakeD 
	LD H,D 
	LD L,E 
	DEC HL 
	DEC HL 
	LD BC,0026 
	LDDR 
	POP HL 
	LD (SnakeB),HL
@NoKey
	LD HL,(SnakeB) 
	PUSH HL 
	LD HL,SnakeB 
	INC HL 
	INC HL 
	LD A,08 
	LD BC,(SnakeA) 
	AND A 
	PUSH HL 
	SBC HL,BC 
	POP HL 
	PUSH AF 
	LD E,(HL) 
	INC HL 
	LD D,(HL) 
	INC HL 
	POP AF 
	JR Z +3
	LD (DE),A 
	JR -16
	LD A,06 
	LD (DE),A 
	POP HL 
	LD (HL),34			;Head, O
	LD BC,0169 
	LD HL,(DFile)
	ADD HL,BC 
	DEC HL 
	LD A,8D 
	CPDR 
	INC HL 
	JP PO Snake02
	LD DE,0011 
	ADD HL,DE 
	LD A,(HL) 
	CP 80				 ;Background
	JR Z +10
	CP 08				 ;Gray body
	JR Z +41
	CP 06				 ;Rattler
	JR Z +25
	JR +2
	LD (HL),8D 
	AND A 
	SBC HL,DE 
	LD (HL),80 
	PUSH HL 
	PUSH BC 
	LD BC,SnakeB 
	LD HL,(SnakeA) 
	AND A 
	SBC HL,BC 
	POP BC 
	POP HL 
	RET Z 
	JR -51
	PUSH HL 
	LD HL,(SnakeA) 
	DEC HL 
	DEC HL 
	LD (SnakeA),HL 
	POP HL 
	JR -35
	AND A 
	SBC HL,DE 
	JR -68
@Snake02
	LD HL,(SnakeB) 
	LD A,(Frames)
	RLA 
	RLA 
	RLA 
	XOR L 
	CP 00
	JR C +19
	AND 0F 
	LD HL,(DFile)
	LD DE,0005 
	ADD HL,DE 
	LD C,A 
	LD B,00 
	ADD HL,BC 
	LD A,(HL) 
	CP 06				 ;Rattler
	LD (HL),8D 			 ;g$
	RET Z 
	JP Snake01
;=======================================
; New keysort
;=======================================
@NewSort
        LD B,00
	CP "O"				;Left
	JR Z RetA			;Return 0 with Z=1
	INC B
	CP "A"				;Down
	JR Z RetA			;Return 1 with Z=1
	INC B
	CP "Q"				;Up
	JR Z RetA			;Return 2 with Z=1
	INC B
	CP "P"				;Right
	JR Z +1				;Return 3 with Z=1
	INC B				;Return 4 with Z=0
@RetA
	LD A,B
	RET
;=======================================
@SnakeA
	84 40 
@SnakeB
	5D 43 5C 43 5B 43 5A 43 
	59 43 58 43 57 43 56 43 
	55 43 54 43 53 43 52 43 
	51 43 52 43 53 43 54 43 
	55 43 56 43 57 43 
@SnakeC
	58 
@SnakeD
	43 
@SnakeE
	10 22 00 12 
@SnakeF
	0B 
@SnakeG
	93 