;================================
;          ZX-Assembler-2 
;      by Artic Computing LTD
;================================

ORG 5BD4			;23508

@PrintAt=08F5
@DFile=400C
@Frames=4034
@Score=48F5
@HiScore=4905
@Speedx=4998			;18840, Speed variable
@Scroll21=487D

;================================
; Scramble
;================================
@Scramble
	CALL Scroll21
	LD (Speed+1),A
	LD B,0F			;Print floor
	CALL PrintAt
	LD B,14
	LD A,03
	RST 10
	DJNZ -3
	CALL PrintAt
	LD C,0F 
	LD B,14 
	XOR A 
	RST 10
	DJNZ -3
	LD A,76
	RST 10			;Print N/L
	DEC C 
	JR NZ -13
	LD DE,(DFile)
	PUSH DE 
	INC DE 
	LD HL,Score 
	LD C,14 
	LDIR 
	POP HL 
	LD DE,0016 
	ADD HL,DE 
	LD (ScramV1),HL 
	SBC HL,HL 
	LD (ScramV2),HL 
@Scram01
	LD HL,(ScramV1) 
	XOR A 
	LD DE,0015 
;Up/Down
	LD A,FB
	IN A,FE 		;Keyboard Port.
	CP +126 		;Up?
	JR NZ +4		;Jump if not up key
	SBC HL,DE 
	JR Up
	LD A,FD
	IN A,FE			;Keyboard Port.
	CP +126			;Up?
	JR NZ +1
	ADD HL,DE
@Up
	LD C,(HL) 
	LD A,C 
	CP D 
	JR Z Scram02
	CP 38			;"S", Top edge detection
	JR NZ +3
	ADD HL,DE 
	JR Scram02
	LD C,76 		;EOL
	CP C 
	JP NZ Crash
	SBC HL,DE 
@Scram02
	LD (HL),">"		;Ship
	LD (ScramV1),HL 
	LD HL,(ScramV2) 
	XOR A 
	CP H 
	JR NZ Scram03
@Fire
	LD A,7F			;Section 7
	IN A,FE			;Keyboard Port.
	CP +123			;"M" Key?
	JR NZ Speed		;Jump if not fire key
	LD HL,(ScramV1) 
	INC HL 
@Scram03
	LD B,(HL) 
	LD A,B 
	CP D 
	JR Z Empty		;No target
	LD B,0A 		;Score 10 points
	CP 34 			;"O",  Fuel hit
	JR Z Fuel
	LD B,02 		;Score 2 points
	CP 26			;"A",  Rocket-A hit
	JR Z RocketA
	CP 97			;"g*", Rocket-* hit
	JR Z +4
	CP BB			;"V",  Rocket-V hit
	JR NZ RocketV
	LD (HL),D		;Erase Rocket-* 
	SBC HL,DE 
@RocketA
	LD (HL),D		;Erase Rocket-A 
	ADD HL,DE 
@Fuel
	LD (HL),D 		;Erase Fuel or Rocket-*
@Scram06
	PUSH BC 
	LD HL,(DFile)
	LD DE,000E 
	ADD HL,DE 		;1st digit of score
	PUSH HL 
	PUSH HL 
	LD E,06 
	ADD HL,DE 		;1st digit of Hiscore
	POP DE 			;Compare score & hiscore
	LD B,04 
	LD A,(DE) 
	CP (HL) 
	JR NZ Scram07
	DEC HL 
	DEC DE 
	DJNZ -8
	LD HL,(DFile)		;Update HiScore
	LD DE,0014
	ADD HL,DE 		;HiScore
	CALL Update
@Scram07
	POP HL 
	CALL Update
	POP BC 
	DJNZ Scram06
@RocketV
	SBC HL,HL 
	LD (ScramV2),HL 
	JR Speed
@Empty
	INC HL 
	XOR A 
	CP (HL) 
	JR NZ Scram03
	LD (ScramV2),HL 
	LD (HL),16		;"-", Missile 
@Speed
	LD B,19			;Delay
	DEC C 
	JR NZ -3
	DJNZ -5
	LD (HL),B 		;Scroll left
	LD HL,(DFile)
	LD C,15 
	ADD HL,BC 
	PUSH HL 
	POP DE 
	LD A,0E 		;Row count
	INC HL 
	INC HL 
	INC DE 
	LD C,13 		;Column count
	LDIR 
	INC DE 
	DEC A 
	JR NZ -11
	LD HL,(DFile)
	PUSH HL 
	LD C,0F 		;Row count
@Scram11
	LD B,15 		;Column count
@Scram12
	INC HL 
	LD A,97			;"g*", Rocket-*
	CP (HL) 
	JR NZ +15
	LD A,(Frames)		;Random number
	DEC A 
	LD (Frames),A
	AND 1F			;Range 0 to 31
	CP 00
	JR NZ +2		;Jump if not 0
	LD (HL),BB		;"V", Rocket-V
	DJNZ Scram12		
	DEC C 
	JR NZ Scram11
	LD DE,0015 		;Row offset
	POP HL 
	LD C,0F			;Row count 
@Scram13
	LD B,15 		;Column count
@Scram14
	INC HL 
	LD A,BB			;"V", Rocket-V
	CP (HL) 
	JR NZ Scram15
	LD (HL),D 
	SBC HL,DE 
	LD (HL),BB		;"V", Rocket-V
	SBC HL,DE 
	XOR A 
	CP (HL) 
	JR Z +9
	LD A,">"		;Ship 
	CP (HL) 
	JR Z +4
	ADD HL,DE 
	LD (HL),D 
	JR +3
	LD (HL),26		;"A", Rocket-A 
	ADD HL,DE 
	ADD HL,DE 
@Scram15
	DJNZ Scram14
	DEC C 
	JR NZ Scram13
	LD HL,(DFile)
	LD DE,0015 
	ADD HL,DE 
	ADD HL,DE 
	DEC HL 
	LD A,(Frames)
	AND 07			;Range 0 to 7
	ADD A,04 		;range 4 to 11
	LD B,A 
	LD (HL),D 
	ADD HL,DE 
	DEC A 
	JR NZ -6
	LD A,(ScramV3) 
	CP D 
	JP Z Scram17
	XOR A 
	LD (ScramV3),A 
	LD A,B 
	LD (HL),26		;"A", Rocket-A 
	INC A 
	ADD HL,DE 		;Next row
	LD (HL),97		;"g*", Rocket-*
@Tower
	ADD HL,DE 		;Next row
	LD A,(HL)			
	CP 03			;Floor chr?
	JP Z Scram01		;Jump if floor chr
	LD (HL),08		;Gray Tower
	JR Tower		;Loop until floor reached
@Scram17
	INC A 
	LD (ScramV3),A 
	LD A,(Frames)
	CP C8			;200
	JR C +4
	LD (HL),34 
	JR +1
	LD (HL),D 
	LD A,B 
	JR Tower
@Crash
	LD (HL),BD		;"gX" 
	LD HL,(DFile)		;Save HiScore
	LD DE,0011 
	ADD HL,DE		;DFile HiScore 
	LD DE,HiScore 		;Saved HiScore
	LD BC,0004 
	LDIR 			;Copy HiScore
	RET
;================================
;Update score
;================================
@Update
	INC (HL) 		;Get digit
	LD A,26 		;"A"
	CP (HL) 		;Test digit
	RET NZ			;Return if not "A" 
	LD (HL),1C 		;"0", Replace "A" with "0"
	DEC HL 			;Next digit
	JR -10
;================================
@ScramV1
	00 00
@ScramV2
	00 00
@ScramV3
	00
