;================================
;          ZX-Assembler-2 
;      by Artic Computing LTD
;================================

@CLS=0A2A
@DFile=400C
@LastK=4025			;Keyboard debounce value
@Frames=4034
@PRBuff00=403C
@PRBuff02=403E
@Easy=4036
@SpeedX=4998			;18840

ORG 5E36			;24118

;================================
; Asteroids
;================================

@Asteroids
	CALL CLS
	LD HL,9C9C 		;Reset highscore
	LD (HiScore),HL 
	LD (HiScore+2),HL
	LD A,(SpeedX)
	LD (Speed+1),A
	LD A,(Easy)
	LD (AstroCount+1),A
	LD DE,(DFile)		;Copy score line
	INC DE 
	LD HL,ScoreX
	LD BC,0020 
	LDIR 
@Astro01
	LD HL,(DFile)		;Reset timer
	LD DE,0014 
	ADD HL,DE 
	LD (HL),A5		;"g9" 
	INC HL 
	LD (HL),A5 		;"g9"
	LD E,0C 
	ADD HL,DE 
	LD A,01 
	LD (PRBuff00),A
	LD A,63			;99 
	LD (PRBuff02),A		;Set timer to 99
	LD C,09 		;Row count
	LD B,20 		;Column count
	INC HL 
	LD (HL),80 		;Print background
	DJNZ -5
	INC HL 
	DEC C 
	JR NZ -11
@Astro02
	LD HL,PRBuff00
	LD B,92			;"g>"
	LD A,(LastK)		;Get keypress value
	CP DF			;Right Key?, Q,W,E,R,T
	JR NZ +1		;Jump if not right key
	INC (HL) 		;Switch direction
	CP FB			;Left key? Y,U,I,O,P
	JR NZ +3		;Jump if not left key
	DEC (HL) 		;Switch direction
	LD B,93 		;"g<"
	LD A,(PRBuff00)
	CP 00
	JR NZ +2
	INC (HL) 
	INC A 
	LD HL,(DFile)
	LD DE,0021 
	ADD HL,DE 
	LD E,A 
	ADD HL,DE 
	CP 20			;32-"4"
	JR Z MadeIt
	LD A,B4 		;"g0"
	CP (HL) 
	JP Z Crash
	LD (HL),B 		;Print ship
@Speed
	LD B,16 
	DEC C
	JR NZ -3
	DJNZ -5
	LD HL,(DFile)
	LD E,15
	ADD HL,DE 		;1st digit of time
	DEC (HL) 		;decrease 1st digit
	LD A,9B 		;"g."
	CP (HL) 
	JR NZ +5
	LD (HL),A5 		;Set 1st digit to "g9"
	DEC HL 			;2nd digit
	JR -11
	LD HL,PRBuff02 
	DEC (HL) 
	JR Z Crash
	LD C,21			;Scroll play area up 
	LD HL,(DFile)
	ADD HL,BC 
	PUSH HL 
	POP DE 
	ADD HL,BC 
	LD BC,0108 		;Byte count, 264
	LDIR 	
	LD B,20 		;Erase last row
	DEC HL 
	LD (HL),80 
	DJNZ -5
@AstroCount
	LD B,01 		;Higher difficulty=more asteroids
	INC B 
@Astro03
	PUSH HL 
	LD DE,(Frames)		;Locate "random" ROM location
	LD D,00 
	LD A,(DE) 		;Get value there
	AND 1F 			;Range=0 to 31
	LD E,A 
	ADD HL,DE 		;Asteroid position
	LD (HL),B4 		;Print asteroid, "gO"
	LD HL,Frames 		;???
	DEC (HL) 
	POP HL 
	DJNZ Astro03
	CALL Score
	JP Astro02
@MadeIt
	LD (HL),8D 		;"g$", Success
	LD B,64			;100
	PUSH BC 
	CALL Score
	POP BC 
	DJNZ -7
	DEC C 			;Delay
	JR NZ -3
	DJNZ -5
	LD A,(Speed+1)
	SUB 05
	LD (Speed+1),A
	JP Astro01
;================================
; Scoring
;================================
@Score
	LD HL,(DFile)		;Update score
	LD BC,000C 
	ADD HL,BC 		;Score 1st digit 
	PUSH HL 
	POP DE 
	PUSH DE 
	LD C,12 
	ADD HL,BC 
	LD B,04 
	LD A,(DE) 
	CP (HL) 
	JR NZ Astro04
	DEC HL 
	DEC DE 
	DJNZ -8
	LD HL,(DFile)		;Update highscore
	LD C,1E 
	ADD HL,BC 		;Highscore 1st digit
	CALL RollOver
@Astro04
	POP HL 
	CALL RollOver
	RET
;==========================
; Rollover scoring digits
;==========================
@RollOver
	INC (HL) 
	LD A,A6 		;"gA"
	CP (HL) 
	RET NZ 
	LD (HL),9C 		;"g0"
	DEC HL 
	JR RollOver
;==========================
; Hit asteroid
;==========================
@Crash
	LD (HL),97 		;"g*"
	LD HL,(DFile)
	LD E,1B 
	ADD HL,DE 		;Save highscore to data area
	LD DE,HiScore 
	LD BC,0004 
	LDIR 
	RET
;==========================
@ScoreX
	80 80 B8 A8 B4 B7 AA 80
	9C 9C 9C 9C 80 80 AB BA
	AA B1 80 A5 A5 80 80 AD
	AE 80
@HiScore
	9C 9C 9C 9C 80 80