;==========================
;          ZX-Assembler-2 
;      by Artic Computing LTD
;==========================

ORG 5F86

@DFile=400C
@Frames=4034
@Skill=4998			;18840

;=============================
;Scramble screen
;=============================
@Scramble			;16516
	LD A,(Skill)		;Scramble Level
	INC A			;A>=1
	LD B,A
@Nxt1
	PUSH BC
	CALL SWAP
	POP BC
	DJNZ NXT1
	RET
;=============================
;Random row in the range 2 to 19
;=============================
@GetRow
	CALL Rnd8Bit
	CP 12			;If > 18 then try again.
	JR NC GetRow
	ADD A,01		;Range=2 to 19
	LD B,A
	RET
;=============================
;Random column in the range 4 to 27
;=============================
@GetCol
	CALL Rnd8Bit
	CP 18			;If > 24 then try again.
	JR NC GetCol
	ADD A,03		;Range=4 to 27
	LD B,00
	LD C,A
	RET
;=============================
;Reverse pieces in the 3x3 grid
;=============================
@Swap
	CALL GetRow		;Random row count
	LD HL,(DFile)
	INC HL
@AddRow
	LD DE,0021
	ADD HL,DE
	DJNZ AddRow
	PUSH HL
	CALL GetCol		;Random column count
	POP HL
	ADD HL,BC		;HL=NW corner of the 3x3 grid
	PUSH HL			
	LD DE,0000		;Row 1
	CALL Invert
	POP HL			;Row 2
	LD E,21
	PUSH HL
	CALL Invert
	POP HL			;Row 3
	LD E,42
	CALL Invert
	RET
;=============================
;Reverse 3 pieces per 3x3 grid line
;=============================
@Invert
	ADD HL,DE
	LD B,03
@Inv1
	LD A,(HL)
	ADD A,80
	LD (HL),A
	INC HL
	DJNZ Inv1
	RET
;================================
; 8-Bit Random Number Generator
; Reg BC not used
; On exit...
;  Reg A=random number in the
;        range 0 to 255
;================================
@Rnd8Bit
	LD DE,0000		;Seed
	LD HL,(Frames)     	;Create pointer to ROM address
	DEC DE	
	ADD HL,DE
	LD A,H
	AND 1F
	LD H,A			;Limit address to <=8192
	LD (Rnd8Bit+1),HL	;New seed
	LD A,(HL)		;Get value at ROM address
	AND 1F			;A=0 TO 31
	RET
