;================================
;          ZX-Assembler-2 
;      by Artic Computing LTD
;================================

@Keyboard=02BB
@Decode=07BD
@DFile=400C
@Easy=4036				;16436
@SpeedX=4998				;18840
@Frames=4034
@Scroll21=487D

ORG 5FF9				;

;================================
;Zaxman
;================================
@ZaxMan
	CALL MazeA
@Zax01
	CALL RND8Bit
	AND 03				;Range 0 to 3
	LD (Ghosts),A
	CALL RND8Bit
	AND 03				;Range 0 to 3
	LD (Ghosts+1),A
@Speed					;Delay Loop
	LD B,16 
	DEC C
	JR NZ -3
	DJNZ -5
	CALL Pacman			;Move
	CP 01				;Caught?
	JR Z Caught			;Jump if caught
	AND A				;0=Board cleared
	JR NZ Zax01			;Loop if not cleared
	CALL MazeB			;New maze
	JR Zax01			;Start loop with new maze
@Caught
	LD A,(SetCount)			;Calculate score
	LD BC,0048
	LD HL,0000
@Zax02
	ADD HL,BC
	DEC A
	JR NZ Zax02
	SBC HL,BC
	LD A,(Score)
	LD C,A
	ADD HL,BC
	LD B,H
	LD C,L
	RET				;Return score to BASIC
;================================
;Pacman Data
;================================
@Pac082
	69 44
@Pac084
	18 44
@Pac086
	97 1B				;"g*."
@Pac088
	69 44
@Pac08A
	02 02
@Pac08C
	01 00 FF FF 11 00 EF FF 
	00 00 
@MoveQAOP
	04 
@Score
	01 				;40CB/16587
@SetCount				;40CC/16588
	01 
@Ghosts
	02 02 00 			;INT (RND*4)
;================================
;Convert byte value to wall or dot
;================================
@Build
	LD B,08				;Counter
	SLA A				;Rotate left
	PUSH AF
	JR NC Dots			;If NC print dot chr
;Walls
	LD A,80 			;Else print wall chr
	RST 10
	JR +3
@Dots
	LD A,"."			;Print dot
	RST 10
	POP AF 
	DJNZ Build+2			;Loop
	RET
;================================
; Print Maze
;================================
@MazeA
	LD A,(Easy)			;Get speed up value
	LD (SpeedUp+1),A		;Set speed up value
	LD A,01
	JR +4
@MazeB
	LD A,(SetCount)
	INC A
	LD (SetCount),A			;Reset SetCount to 0
	LD A,(SpeedX)
@SpeedUp
	SUB 05
	LD (SpeedX),A
	LD (Speed+1),A
	CALL Scroll21 
	LD HL,Score			;Reset score to 0
	LD (HL),00
@Retry					;Locate random maze
	CALL RND8Bit
	AND 07				;Range 0 to 7
	CP 04				;Test value
	JR NC Retry			;Retry if>4
	LD B,A
	INC B				;Counter, range 1 to 5
	LD A,18				;Maze base addr Lo byte-21
@MazeAddr
	ADD A,14			;A=A+20
	DJNZ MazeAddr
	LD H,49				;Maze base addr Hi byte
	LD L,A				;Maze base addr Lo byte
	LD B,0A				;Row count 
@NxtRow
	LD C,02				;Row Left/Right
	PUSH BC 
	INC HL 
	PUSH HL 
	LD A,(HL) 
	CALL Build
	POP HL 
	POP BC 
	DEC C 
	JR NZ NxtRow+2
	LD A,76 
	RST 10
	DJNZ NxtRow
	LD HL,Pac086 
	LD (HL),"."
	INC HL 
	LD (HL),"." 
	INC HL 
	INC HL 
	INC HL 
	LD (HL),04 
	INC HL 
	LD (HL),04 
	LD HL,(DFile)
	LD DE,0013 
	ADD HL,DE 
	LD (Pac082),HL 
	LD DE,000D 
	ADD HL,DE 
	LD (Pac084),HL 
	LD DE,0055 
	ADD HL,DE 
	LD (Pac088),HL 
	LD BC,(SetCount) 		;Return setcount to BASIC
	RET
;================================
; Game Play
;================================
@Pacman
	LD A,04 
	LD (MoveQAOP),A 
	CALL Keyboard
	INC L 
	JR Z NotQAOP
	DEC L 
	LD C,L 
	LD B,H 
	CALL Decode
	LD A,(HL) 
	LD HL,MoveQAOP 
@QKey
	CP "Q"
	JR NZ AKey
	LD (HL),03 
@AKey
	CP "A"
	JR NZ OKey
	LD (HL),02 
@OKey
	CP "O"
	JR NZ Pkey
	LD (HL),01 
@PKey
	CP "P"
	JR NZ NotQAOP
	LD (HL),00 
@NotQAOP
	LD A,(MoveQAOP) 
	ADD A,A 
	LD HL,Pac08C 
	ADD A,L 
	LD L,A 
	LD E,(HL) 
	INC HL 
	LD D,(HL) 
	LD HL,(Pac088) 
	ADD HL,DE 
	LD A,(HL) 
	LD HL,MoveQAOP 
	CP 80
	JR NZ Pac162
	LD (HL),04 
@Pac162
	INC HL 
	CP "."
	JR NZ Pac168
	INC (HL) 
@Pac168
	LD B,02 
@Pac16A
	PUSH BC 
	LD C,00 
	LD A,(Pac08A) 
	ADD A,A 
	LD HL,Pac08C 
	ADD A,L 
	LD L,A 
	LD E,(HL) 
	INC HL 
	LD D,(HL) 
	LD HL,(Pac082) 
	PUSH DE 
	PUSH HL 
	LD HL,FFFF 
	AND A 
	SBC HL,DE 
	JR Z Pac1A0
	LD HL,0001 
	AND A 
	SBC HL,DE 
	JR Z Pac1A0
	POP HL 
	PUSH HL 
	LD DE,FFFF 
	ADD HL,DE 
	LD A,80 
	CP (HL) 
	JR NZ Pac1B4
	INC HL 
	INC HL 
	CP (HL) 
	JR NZ Pac1B4
	JR Pac1B6
@Pac1A0
	POP HL 
	PUSH HL 
	LD DE,FFEF 
	ADD HL,DE 
	LD A,80 
	CP (HL) 
	JR NZ Pac1B4
	LD DE,0022 
	ADD HL,DE 
	CP (HL) 
	JR NZ Pac1B4
	JR Pac1B6
@Pac1B4
	LD C,01 
@Pac1B6
	POP HL 
	POP DE 
	XOR A 
	CP C 
	JR Z Pac1DD
@Pac1BC
	LD A,(Ghosts) 			;Ghost count
	LD (Pac08A),A 
	PUSH HL 
	LD HL,Pac08C 
	ADD A,A 
	ADD A,L 
	LD L,A 
	LD E,(HL) 
	INC HL 
	LD D,(HL) 
	POP HL 
	PUSH HL 
	ADD HL,DE 
	LD A,(HL) 
	POP HL 
	CP 80
	JR NZ Pac1DD
	LD DE,0000 
	LD A,04 
	LD (Pac08A),A 
@Pac1DD
	PUSH HL 
	ADD HL,DE 
	LD A,(HL) 
	POP HL 
	CP 80
	JR Z Pac1BC
	LD A,(Pac086) 
	CP B4				;"gO"
	JR Z Pac1ED
	LD (HL),A 
@Pac1ED
	ADD HL,DE 
	LD (Pac082),HL 
	LD A,(HL) 
	LD (Pac086),A 
	LD (HL),B4 			;"gO"
	LD C,00 
	EX DE,HL 
	LD HL,(Pac088) 
	PUSH DE 
	PUSH HL 
	AND A 
	SBC HL,DE 
	JR NZ Pac206
	LD C,01 
@Pac206
	LD A,(MoveQAOP) 
	ADD A,A 
	LD HL,Pac08C 
	ADD A,L 
	LD L,A 
	LD E,(HL) 
	INC HL 
	LD D,(HL) 
	POP HL 
	ADD HL,DE 
	POP DE 
	AND A 
	SBC HL,DE 
	JR NZ Pac21C
	LD C,01 
@Pac21C
	LD A,C 
	POP BC 
	CP 01
	RET Z
;================================
@Pac23C
	LD HL,(Pac082) 
	LD DE,(Pac084) 
	LD (Pac084),HL 
	LD (Pac082),DE 
	LD HL,Pac086 
	LD D,(HL) 
	INC HL 
	LD E,(HL) 
	LD (HL),D 
	DEC HL 
	LD (HL),E 
	LD HL,Pac08A 
	LD D,(HL) 
	INC HL 
	LD E,(HL) 
	LD (HL),D 
	DEC HL 
	LD (HL),E 
	LD HL,Ghosts 
	LD D,(HL) 
	INC HL 
	LD E,(HL) 
	LD (HL),D 
	DEC HL 
	LD (HL),E 
	DEC B 
	JP NZ Pac16A
	LD HL,(Pac088) 
	LD (HL),00 
	PUSH HL 
	LD HL,Pac08C 
	LD A,(MoveQAOP) 
	ADD A,A 
	ADD A,L 
	LD L,A 
	LD E,(HL) 
	INC HL 
	LD D,(HL) 
	POP HL 
	ADD HL,DE 
	LD (Pac088),HL 
	LD (HL),97 			;"g*"
	LD A,(Score) 
	CP 49 				;73? Max score/set
	JR NZ NotCleared
;Cleared
	LD A,00
	RET				;Return 16384
;================================
@NotCleared
	LD A,02
	RET
;================================
; 8-Bit Random Number Generator
; Reg BC not used
; On exit...
;  Reg A=random number in the
;        range 0 to 255
;================================
@Rnd8Bit
	LD DE,0000		;Seed
	LD HL,(Frames)     	;Create pointer to ROM address
	DEC DE	
	ADD HL,DE
	LD A,H
	AND 1F
	LD H,A			;Limit address to <=8192
	LD (Rnd8Bit+1),HL	;New seed
	LD A,(HL)		;Get value at ROM address
	RET