;================================
;          ZX-Assembler-2 
;      by Artic Computing LTD
;================================

ORG 487D			;18557

@PrintAt=08F5
@Scroll=0C0E			;ROM's SCROLL routine
@DFile=400C			;Address of display file
@LastK=4025			;Keyboard debounce value
@XCoord=4036
@Speed=4998			;18840, Speed variable

;================================
;Scroll21
;
; Collapse DFile by using the 
; ROM's scroll routine
;================================
@Scroll21			;18557
	LD (IY+34),02		;Set DFile to 21 lines before scrolling
	LD B,16			;Lines to scroll counter
	PUSH BC			;PUSH counter
	CALL Scroll
	POP BC			;POP counter
	DJNZ Scroll21+6		;Loop until B=0
	LD C,00			;BC=0
	CALL PrintAt		;PRINT AT 0,0
	LD A,(Speed)		;Get speed
	LD HL,Scroll21+5
	LD (HL),16		;Reset counter
	RET
;================================
;Wait
;================================
@Wait
	LD A,(LastK)		;Get key section value
	CP FF			;Key press test
	JR NZ Wait		;Loop if key being depressed
	RET
;================================
;WaitYN
;
; Wait for Y/N response
;================================
@WaitYN 			;18588
	CALL Wait
	LD BC,0000		;Set return value to 0
@YNLoop
	LD A,7F			;Section 7
	IN A,FE 		;Keyboard Port.
	CP +119 		;"N" key?
	JR Z Wait		;Return 0 if N pressed
	LD A,DF			;Section 5
	IN A,FE 		;Keyboard Port.
	CP +111 		;"Y" Key?
	JR NZ YNLoop		;Loop until Y or N key pressed
	INC C			;Set BC for return
	JR Wait			;Return 1 to BASIC
;==========================
; Scroll Up
;==========================
@ScrollUp			;18612
	LD HL,(DFile)
	LD D,H
	LD E,L
	LD BC,0021 
	ADD HL,BC 
	LD BC,02F7 
	LDIR
	LD C,21
	SBC HL,BC
	LD C,B
	LD B,20 
	INC HL 
	LD (HL),C
	DJNZ -4
	RET
	00 00 00
;==========================
; Defender Data
;==========================
@Score
	B8 A8 B4 B7 AA 92 9C 9C
	9C 8A 8A A9 AA AB AA B3
	A9 AA B7 8A 8A AD AE 92
	9C 9C 9C
@HiScore
	00
